diff --git a/test/fops/file.c b/test/fops/file.c
index 1bb13f8a4..fa231134b 100644
--- a/test/fops/file.c
+++ b/test/fops/file.c
@@ -40,6 +40,7 @@ obj_bulk(void)
 	if ((ret = conn->open_session(conn, NULL, NULL, &session)) != 0)
 		testutil_die(ret, "conn.session");
 
+	testutil_check(session->begin_transaction(session, NULL));
 	if ((ret = session->create(session, uri, config)) != 0)
 		if (ret != EEXIST && ret != EBUSY)
 			testutil_die(ret, "session.create");
@@ -53,6 +54,10 @@ obj_bulk(void)
 		} else if (ret != ENOENT && ret != EBUSY && ret != EINVAL)
 			testutil_die(ret, "session.open_cursor bulk");
 	}
+	if ((ret = session->commit_transaction(session, NULL)) != 0 &&
+	    ret != EINVAL)
+		testutil_die(ret, "session.commit bulk");
+
 	if ((ret = session->close(session, NULL)) != 0)
 		testutil_die(ret, "session.close");
 }
@@ -76,6 +81,7 @@ obj_bulk_unique(int force)
 	if ((ret = pthread_rwlock_unlock(&single)) != 0)
 		testutil_die(ret, "pthread_rwlock_unlock single");
 
+	testutil_check(session->begin_transaction(session, NULL));
 	if ((ret = session->create(session, new_uri, config)) != 0)
 		testutil_die(ret, "session.create: %s", new_uri);
 
@@ -97,6 +103,9 @@ obj_bulk_unique(int force)
 		if (ret != EBUSY)
 			testutil_die(ret, "session.drop: %s", new_uri);
 
+	if ((ret = session->commit_transaction(session, NULL)) != 0 &&
+	    ret != EINVAL)
+		testutil_die(ret, "session.commit bulk unique");
 	if ((ret = session->close(session, NULL)) != 0)
 		testutil_die(ret, "session.close");
 }
@@ -111,6 +120,7 @@ obj_cursor(void)
 	if ((ret = conn->open_session(conn, NULL, NULL, &session)) != 0)
 		testutil_die(ret, "conn.session");
 
+	testutil_check(session->begin_transaction(session, NULL));
 	if ((ret =
 	    session->open_cursor(session, uri, NULL, NULL, &cursor)) != 0) {
 		if (ret != ENOENT && ret != EBUSY)
@@ -119,6 +129,9 @@ obj_cursor(void)
 		if ((ret = cursor->close(cursor)) != 0)
 			testutil_die(ret, "cursor.close");
 	}
+	if ((ret = session->commit_transaction(session, NULL)) != 0 &&
+	    ret != EINVAL)
+		testutil_die(ret, "session.commit cursor");
 	if ((ret = session->close(session, NULL)) != 0)
 		testutil_die(ret, "session.close");
 }
@@ -132,10 +145,14 @@ obj_create(void)
 	if ((ret = conn->open_session(conn, NULL, NULL, &session)) != 0)
 		testutil_die(ret, "conn.session");
 
+	testutil_check(session->begin_transaction(session, NULL));
 	if ((ret = session->create(session, uri, config)) != 0)
 		if (ret != EEXIST && ret != EBUSY)
 			testutil_die(ret, "session.create");
 
+	if ((ret = session->commit_transaction(session, NULL)) != 0 &&
+	    ret != EINVAL)
+		testutil_die(ret, "session.commit create");
 	if ((ret = session->close(session, NULL)) != 0)
 		testutil_die(ret, "session.close");
 }
@@ -158,14 +175,22 @@ obj_create_unique(int force)
 	if ((ret = pthread_rwlock_unlock(&single)) != 0)
 		testutil_die(ret, "pthread_rwlock_unlock single");
 
+	testutil_check(session->begin_transaction(session, NULL));
 	if ((ret = session->create(session, new_uri, config)) != 0)
 		testutil_die(ret, "session.create");
+	if ((ret = session->commit_transaction(session, NULL)) != 0 &&
+	    ret != EINVAL)
+		testutil_die(ret, "session.commit create unique");
 
 	__wt_yield();
+	testutil_check(session->begin_transaction(session, NULL));
 	while ((ret = session->drop(
 	    session, new_uri, force ? "force" : NULL)) != 0)
 		if (ret != EBUSY)
 			testutil_die(ret, "session.drop: %s", new_uri);
+	if ((ret = session->commit_transaction(session, NULL)) != 0 &&
+	    ret != EINVAL)
+		testutil_die(ret, "session.commit create unique");
 
 	if ((ret = session->close(session, NULL)) != 0)
 		testutil_die(ret, "session.close");
@@ -180,9 +205,13 @@ obj_drop(int force)
 	if ((ret = conn->open_session(conn, NULL, NULL, &session)) != 0)
 		testutil_die(ret, "conn.session");
 
+	testutil_check(session->begin_transaction(session, NULL));
 	if ((ret = session->drop(session, uri, force ? "force" : NULL)) != 0)
 		if (ret != ENOENT && ret != EBUSY)
 			testutil_die(ret, "session.drop");
+	if ((ret = session->commit_transaction(session, NULL)) != 0 &&
+	    ret != EINVAL)
+		testutil_die(ret, "session.commit drop");
 
 	if ((ret = session->close(session, NULL)) != 0)
 		testutil_die(ret, "session.close");