diff --git a/src/btree/bt_read.c b/src/btree/bt_read.c
index 4ac0cb2..e8d42d2 100644
--- a/src/btree/bt_read.c
+++ b/src/btree/bt_read.c
@@ -166,6 +166,11 @@ __las_page_instantiate(WT_SESSION_IMPL *session, WT_REF *ref, uint32_t btree_id)
 	for (; ret == 0; ret = cursor->next(cursor)) {
 		WT_ERR(cursor->get_key(cursor,
 		    &las_pageid, &las_id, &las_counter, &las_key));
+		if (F_ISSET(S2BT(session), WT_BTREE_NO_LOGGING))
+			__wt_verbose(session, WT_VERB_TEMPORARY,
+			    "LAS_INSTANTIATE: table %s btree id %" PRIu32 " key %s",
+			    S2BT(session)->dhandle->name,
+			    las_id, (char *)las_key.data);
 
 		/*
 		 * Confirm the search using the unique prefix; if not a match,
diff --git a/src/btree/bt_split.c b/src/btree/bt_split.c
index 36bbe48..76177cb 100644
--- a/src/btree/bt_split.c
+++ b/src/btree/bt_split.c
@@ -1720,6 +1720,11 @@ __split_insert(WT_SESSION_IMPL *session, WT_REF *ref)
 	else
 		ins_head = WT_COL_APPEND(page);
 	moved_ins = WT_SKIP_LAST(ins_head);
+	if (F_ISSET(S2BT(session), WT_BTREE_NO_LOGGING) &&
+	    !WT_PREFIX_MATCH(session->dhandle->name, "file:WiredTiger"))
+		__wt_verbose(session, WT_VERB_TEMPORARY,
+		    "split_insert: SKIP_LAST key %s",
+		    (char *)WT_INSERT_KEY(moved_ins));
 
 	/*
 	 * The first page in the split is the current page, but we still have
diff --git a/src/cache/cache_las.c b/src/cache/cache_las.c
index 569a024..5262a3b 100644
--- a/src/cache/cache_las.c
+++ b/src/cache/cache_las.c
@@ -8,6 +8,8 @@
 
 #include "wt_internal.h"
 
+uint32_t dbg_id;
+
 /*
  * When an operation is accessing the lookaside table, it should ignore the
  * cache size (since the cache is already full), any pages it reads should be
@@ -583,7 +585,7 @@ __wt_las_insert_block(WT_SESSION_IMPL *session, WT_CURSOR *cursor,
 	uint64_t decrement_cnt, insert_cnt, insert_estimate;
 	uint64_t las_counter, las_pageid;
 	uint32_t btree_id, i, slot;
-	uint8_t *p;
+	uint8_t *p, upd_save;
 	bool local_txn;
 
 	btree = S2BT(session);
@@ -698,13 +700,17 @@ __wt_las_insert_block(WT_SESSION_IMPL *session, WT_CURSOR *cursor,
 			    (upd->type == WT_UPDATE_STANDARD ||
 			    upd->type == WT_UPDATE_MODIFY)) {
 				las_value.size = 0;
+				upd_save = WT_UPDATE_BIRTHMARK;
 				cursor->set_value(cursor,
 				    upd->txnid, &las_timestamp,
 				    WT_UPDATE_BIRTHMARK, &las_value);
 			} else
+			{
 				cursor->set_value(cursor,
 				    upd->txnid, &las_timestamp,
 				    upd->type, &las_value);
+				upd_save = upd->type;
+			}
 
 			/*
 			 * If remove is running concurrently, it's possible for
@@ -725,6 +731,14 @@ __wt_las_insert_block(WT_SESSION_IMPL *session, WT_CURSOR *cursor,
 			 * between inserts.
 			 */
 			WT_ERR(cursor->update(cursor));
+			if (F_ISSET(btree, WT_BTREE_NO_LOGGING)) {
+				__wt_verbose(session, WT_VERB_TEMPORARY,
+				    "LAS_INSERT: from table %s btree id %" PRIu32
+				    " insert key %s upd %" PRIu8, btree->dhandle->name,
+				    btree->id, (char *)key->data, upd_save);
+				if (dbg_id == 0)
+					dbg_id = btree->id;
+			}
 			++insert_cnt;
 		} while ((upd = upd->next) != NULL);
 	}
@@ -775,10 +789,12 @@ int
 __wt_las_cursor_position(WT_CURSOR *cursor, uint32_t btree_id, uint64_t pageid)
 {
 	WT_ITEM las_key;
+	WT_SESSION_IMPL *session;
 	uint64_t las_counter, las_pageid;
 	uint32_t las_id;
 	int exact;
 
+	session = (WT_SESSION_IMPL *)cursor->session;
 	/*
 	 * When scanning for all pages, start at the beginning of the lookaside
 	 * table.
@@ -817,7 +833,9 @@ __wt_las_cursor_position(WT_CURSOR *cursor, uint32_t btree_id, uint64_t pageid)
 			    las_id < btree_id))
 				continue;
 		}
-
+		if (las_id == dbg_id)
+			__wt_verbose(session, WT_VERB_TEMPORARY,
+			    "%s", "LAS_CUR_POSITION: positioned");
 		return (0);
 	}
 
@@ -1138,6 +1156,10 @@ __wt_las_sweep(WT_SESSION_IMPL *session)
 				continue;
 		}
 
+		if (las_id == dbg_id)
+			__wt_verbose(session, WT_VERB_TEMPORARY,
+			    "LAS_SWEEP: btree id %" PRIu32 " key %s upd %" PRIu8,
+			    las_id, (char *)las_key.data, upd_type);
 		WT_ERR(cursor->remove(cursor));
 		++decrement_cnt;
 	}
diff --git a/src/txn/txn_ckpt.c b/src/txn/txn_ckpt.c
index d3f11c5..f84cd99 100644
--- a/src/txn/txn_ckpt.c
+++ b/src/txn/txn_ckpt.c
@@ -953,11 +953,17 @@ __txn_checkpoint(WT_SESSION_IMPL *session, const char *cfg[])
 	txn_global->checkpoint_state.pinned_id = WT_TXN_NONE;
 
 	if (full) {
-		__checkpoint_stats(session);
 #ifdef HAVE_TIMESTAMPS
+		char hex_ts[2 * WT_TIMESTAMP_SIZE + 1];
+
 		__wt_timestamp_set(
 		    &conn->txn_global.last_ckpt_timestamp, &ckpt_tmp_ts);
+		(void)__wt_timestamp_to_hex_string(
+		    session, hex_ts, &ckpt_tmp_ts);
+		__wt_verbose(session, WT_VERB_TEMPORARY,
+		    "CKPT COMPLETE: checkpoint timestamp %s", hex_ts);
 #endif
+		__checkpoint_stats(session);
 	}
 
 err:	/*
diff --git a/test/csuite/timestamp_abort/main.c b/test/csuite/timestamp_abort/main.c
index a15baa0..e3e92bf 100644
--- a/test/csuite/timestamp_abort/main.c
+++ b/test/csuite/timestamp_abort/main.c
@@ -80,10 +80,10 @@ static volatile uint64_t th_ts[MAX_TH];
 
 #define	ENV_CONFIG_COMPAT	",compatibility=(release=\"2.9\")"
 #define	ENV_CONFIG_DEF						\
-    "create,log=(archive=false,file_max=10M,enabled)"
+    "create,log=(archive=false,file_max=10M,enabled),verbose=(temporary)"
 #define	ENV_CONFIG_TXNSYNC					\
     "create,log=(archive=false,file_max=10M,enabled),"			\
-    "transaction_sync=(enabled,method=none)"
+    "transaction_sync=(enabled,method=none),verbose=(temporary)"
 #define	ENV_CONFIG_REC "log=(archive=false,recover=on)"
 
 typedef struct {
@@ -184,10 +184,11 @@ thread_ckpt_run(void *arg)
 	WT_RAND_STATE rnd;
 	WT_SESSION *session;
 	THREAD_DATA *td;
-	uint64_t ts;
+	uint64_t stable;
 	uint32_t sleep_time;
 	int i;
 	bool first_ckpt;
+	char buf[128];
 
 	__wt_random_init(&rnd);
 
@@ -198,20 +199,20 @@ thread_ckpt_run(void *arg)
 	(void)unlink(ckpt_file);
 	testutil_check(td->conn->open_session(td->conn, NULL, NULL, &session));
 	first_ckpt = true;
-	ts = 0;
 	for (i = 0; ;++i) {
 		sleep_time = __wt_random(&rnd) % MAX_CKPT_INVL;
 		sleep(sleep_time);
-		if (use_ts)
-			ts = global_ts;
 		/*
 		 * Since this is the default, send in this string even if
 		 * running without timestamps.
 		 */
 		testutil_check(session->checkpoint(
 		    session, "use_timestamp=true"));
-		printf("Checkpoint %d complete.  Minimum ts %" PRIu64 "\n",
-		    i, ts);
+		testutil_check(td->conn->query_timestamp(
+		    td->conn, buf, "get=last_checkpoint"));
+		sscanf(buf, "%" SCNx64, &stable);
+		printf("Checkpoint %d complete. Ckpt at stable %"
+		    PRIu64 ".\n", i, stable);
 		fflush(stdout);
 		/*
 		 * Create the checkpoint file so that the parent process knows
@@ -638,7 +639,7 @@ main(int argc, char *argv[])
 		    use_ts ? "true" : "false");
 		printf("Parent: Create %" PRIu32
 		    " threads; sleep %" PRIu32 " seconds\n", nth, timeout);
-		printf("CONFIG: %s%s%s%s -h %s -T %" PRIu32 "-t %" PRIu32 "\n",
+		printf("CONFIG: %s%s%s%s -h %s -T %" PRIu32 " -t %" PRIu32 "\n",
 		    progname,
 		    compat ? " -C" : "",
 		    inmem ? " -m" : "",